<?php
/***************************************************************************
*                            instant_messenger.php
*                           -----------------------
*  	Begin: 				2010-01-03
*  	Copyright: 			Dakin Quelia
*  	Email: 				dakinquelia@hotmail.com
*	Author notes:		Mod original by (C) Spitfire Pat 
***************************************************************************/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_posting.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/message_parser.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup();

// Output page ...
$user->add_lang('mods/instant_messenger');

$mode 		= request_var('mode', '');
$msg_id 	= request_var('id', 0);
$content 	= utf8_normalize_nfc(request_var('message', '', true));

$dest		= ($mode == 'send' || $mode == 'reply') ? request_var('dest', 0) : $user->data['user_id'];
$time 	 	= time();
$error		= '';

$submit 	= (isset($_POST['submit'])) ? true : false;

add_form_key('posting');

// Checking mode.
if (!in_array($mode, array('send', 'read', 'reply')))
{
	trigger_error('NO_MODE');
}

// Is the user able to read within this page?
if ($user->data['user_id'] == ANONYMOUS || !$user->data['is_registered'])
{
	login_box('', $user->lang['LOGIN_EXPLAIN_IM']);
}

//
switch($mode)
{	
	case 'read':
		
		// If not message error displays
		if (!$msg_id)
		{
			trigger_error('NO_MSG');
		}
	
		$sql_arr = array(
			'SELECT'    => 'u.user_id, u.username, u.user_colour, im.sender_id, im.dest_id, im.date_msg, im.message',
			'FROM'      => array(INSTANTMESSENGER_TABLE  => 'im'),
			'LEFT_JOIN' => array(
				array(
					'FROM' => array(USERS_TABLE => 'u',),
					'ON' 	=> 'im.sender_id = u.user_id'),
			),				
			'WHERE'			=> 'im.msg_id =' . $msg_id,
		);
		$sql = $db->sql_build_query('SELECT', $sql_arr);
		$result = $db->sql_query($sql);
		$messenger = $db->sql_fetchrow($result);
			
		$template->assign_vars(array(	
			'SENDER' 			=> get_username_string('full', $messenger['sender_id'], $messenger['username'], $messenger['user_colour']),
			'DEST' 				=> get_username_string('full', $messenger['dest_id'], $user->data['username'], $messenger['user_colour']),
			'DATE' 				=> $user->format_date($messenger['date_msg']),
			'MESSAGE' 			=> $messenger['message'],
				
			'U_ACTION' 			=> append_sid("{$phpbb_root_path}im.$phpEx", 'mode=reply&amp;dest=' . $messenger['sender_id']),
			)
		);
			
		$sql = "DELETE FROM " . INSTANTMESSENGER_TABLE . " WHERE msg_id = " . $msg_id;
		$result = $db->sql_query($sql);
		$db->sql_freeresult($result);
		
		$template_html = '/mods/instant_messenger/instant_messenger_view.html';
		
	break;
	
	case 'reply':
	case 'send':
		
		// Submission of datas
		if ($submit)
		{
			// check form
			if (!check_form_key('posting'))
			{
				$error[] = $user->lang['FORM_INVALID'];
			}
			
			// If message is empty
            if (empty($content))
            {
                $error[] = $user->lang['MESSAGE_EMPTY'];
            } 
			// If dest_id doesn't exist
			if (empty($dest))
            {
                $error[] = $user->lang['DEST_EMPTY'];
            } 
			
			// If none error then submit
			if ($submit && !$error)
			{
				// Datas
				$sql_array = array(
					'sender_id' 	=> $user->data['user_id'], 
					'dest_id' 		=> $dest,
					'date_msg' 		=> $time, 
					'message' 		=> $content,  
				);
				$sql = 'INSERT INTO ' . INSTANTMESSENGER_TABLE . ' ' . $db->sql_build_array('INSERT', $sql_array);
				$db->sql_query($sql);
				
				$meta_info = append_sid("{$phpbb_root_path}im.$phpEx", 'mode='.$mode);
				meta_refresh(3, $meta_info);
			}
		}
		
		$template->assign_vars(array(
			'MESSAGE'			=> $content,
		
			'S_ERROR'			=> $error,
			'S_SENDER'			=> $sender_id,	
			'S_DEST'			=> $dest,
			'S_READ'			=> true,
			'S_MESSAGE_SUBMIT'	=> !empty($content) ? $content : '', 
		
			'U_ACTION' 			=> append_sid("{$phpbb_root_path}im.$phpEx", 'mode='. $mode . '&amp;dest=' . $dest),
			)
		);
		
		$template_html = '/mods/instant_messenger/instant_messenger_body.html';
		
	break;
}

page_header($user->lang['INSTANT_MESSENGER'], false);
	
$template->set_filenames(array(
	'body' => $template_html)
);	
		
page_footer();

?>